#!/usr/bin/perl

                         ### *** IMPORTANT *** ###

       ### *** Make sure the path to PERL above is correct *** ###


      #################################################################
      #                                                               #
      #                       100 Links Ver 3.0                       #
      #                                                               #
      #                   Free for all Links Program                  #
      #                              by                               #
      #                        Ranson Johnson                         #
      #                                                               #
      # E-Mail: ranson@rlaj.com                                       #
      #                                                               #
      # Script name: 100link.pl                                       #
      #                                                               #
      # Copywrite 1997/2002 by Ranson's Scripts all rights reserved   #
      # Sale or re-distribution of this program without prior written #
      # permision is prohibited.                                      #
      #                                                               #
      #################################################################


                      ### *** IMPORTANT *** ###

### *** If FTP'ing this file, be sure to send in ASCII format *** ###

# You must chmod the cgi's to 755 
# For information on chmod see Ranson's FAQ's


                         ### *** *** ###
                         ### *** *** ###
                         ### *** *** ###

BEGIN {
            eval {
# Get the configuration file location for: UNIX /
                ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
# Get the configuration file location for: Windows \
                ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    

# If you have problems with the path to the 100-configuration.txt 
# (configuration file) - put the complete path to the file
# in the require statement below.
	require ("100-configuration.txt");
	require ("lib/100-lib.pm");
                };
        if ($@) {
                
                print "Content-type: text/html\n\n";
        if ($! =~ /No such file/i) {
                print "Error Finding Configuration File: \n\n";
                print "$@\n";
                print "Make sure the configuration file is in this directory.\n";
                print "You may need to set the path in the require statement.";

        }else{
                print "Error in Configuration File:\n\n";
                print "System Error: \n$@ \n";
                print "Common Errors are:\n";
                print "Missing a semicolon at the end of a line ( ; )\n";
                print "Missing a quote surrounding a value for a variable.\n";
                print "Could be a single quote ( ' ) or double quote( \" )\n\n";
                print "An \@ in an email address needs to be \"escaped\"\n";
                print "If double quotes are used for an email address\n";
                print "you will need to \"escape\" the \@ - ray\\\@ray.com\n\n";
                print "The same is true if you want to print any special \n";
                print "character, you will need to \"escape\" the special \n";
                print "character, with a \\ backslash\n";


        }
        exit;
    }
}


if ($ENV{'HTTP_USER_AGENT'} =~ /EmailSiphon/i) { print "Content-type: text/html\n\n"; print "No-email-robots\@no-robots.com"; exit; }

                        ### *** :) *** ###

$setup_error = "";
if (!-e "$docs_path") { $setup_error = "Path to /100links folder is incorrect: $docs_path\n"; }
if (!-e "$cgi_path") { $setup_error = "Path to /cgi-bin/100links folder is incorrect: $cgi_path\n"; }
if (!-e "$Link_Log") { $setup_error .= "Path to /cgi-bin/logs is incorrect: $cgi_path/logs\n"; }
if (!-w "$Link_Log") { $setup_error .= "Permission setting of the 100link.log is incorrect: Must be 666 or rw-rw-rw\n"; }
if (!-w "$black_list") { $setup_error .= "Permission setting of the blk_list.log is incorrect: Must be 666 or rw-rw-rw\n"; }
if (!-w "$bad_word_log") { $setup_error .= "Permission setting of the badword.log is incorrect: Must be 666 or rw-rw-rw\n"; }
if (!-w "$count_log") { $setup_error .= "Permission setting of the 100count.log is incorrect: Must be 666 or rw-rw-rw\n"; }
if ($setup_error ne "") { &print_setup_error(); }

                        ### *** :) *** ###

&Page_Top();
&Page_Bottom();

	print "Content-Type: text/html\n\n";																																																	
	print $pagetop;
	print qq(<!CONTENT_AUTHOR="Ranson's Scripts - COPYRIGHT 1996/2002 all rights reserved. http://www.rlaj.com">\n);

                        ### *** :) *** ###

# This section opens the links log and formats the links

open(LINKFILE, "$Link_Log") || &open_error("$Link_Log");
@filein = <LINKFILE>;
close(LINKFILE);
$cnt=1;
foreach $link(@filein) {
($link_no, $remote_addr, $email, $url, $sitename, $desc)=split(/\|/, $link);
$post_time = localtime($link_no);
if ($sitename eq "") { $sitename = "No Title"; }
if ($url eq "") { $my_sitename = qq($sitename); }else{ $my_sitename = qq(<A HREF="$url" Target=new>$sitename</A>); }
if ($show_email eq "1") { $my_email = qq(<BR><A HREF="mailto:$email">$email</A> &nbsp; &nbsp; ); }
if ($show_web_addr eq "1") { $my_web_addr = qq(<BR><A HREF="$url" Target=new>$url</A> &nbsp; &nbsp; ); }
$linkline .= qq(<TR><TD><Font face=$fontface Size=$fontsize>$cnt. <B>$my_sitename</B><BR>$desc$my_web_addr$my_email</Font><BR><font face=$fontface size=1>$link_no &nbsp; &nbsp; Posted: $post_time </Font></TD></tr>\n);
if ($seperator ne "") { $linkline .= qq(<TR><TD Align=Center>$seperator</TD></tr>\n); }
$cnt++;
}

                        ### *** :) *** ###

# This section prints the links to the screen
print <<"~EndOfPrint~";
<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 Width="95%" Align=Center>
$linkline
</TABLE>
~EndOfPrint~

                        ### *** :) *** ###


# This section opens the htm file and prints it as the bottom of the page

     print $pagebottom;

                        ### *** :) *** ###

                        ### *** :) *** ###

                        ### *** :) *** ###

print <<"~EndOfPrint~";
<BR><BR>
<BR><BR>
$scripts_page
~EndOfPrint~

# This section is the page counter

open (LOG,"$count_log"); flock(LOG, 2);	$number = <LOG>; flock(LOG, 8); close LOG;
$next_number = $number + 1;
open (LOG,">$count_log"); flock(LOG, 2); print LOG "$next_number"; flock(LOG, 8); close LOG; 


                        ### *** :) *** ###


# This section prints the page count and the bottom of the page

print <<"~EndOfPrint~";
<BR><BR>
<CENTER><FONT COLOR="000000">$next_number</FONT></CENTER>
<BR><BR>
~EndOfPrint~

exit;  

                        ### *** :) *** ###


sub print_setup_error {
print "Content-Type: text/html\n\n";	
print <<"~EndOfPrint~";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<title>Setup Error</title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
<meta NAME="Author" CONTENT="Ranson's Scripts">
<meta NAME="description" CONTENT="">
<meta NAME="keywords" CONTENT="">
</HEAD>
<BODY BGCOLOR="FFFFFF">
<B><FONT FACE="Arial" COLOR="000080" SIZE="+1">Setup Error</FONT></B>
<BR><BR>
# For Path and Permission help - see: http://www.rlaj.com/scripts/helpdesk

<PRE>

$setup_error
</PRE>
</BODY>
</HTML>

~EndOfPrint~
exit;
} # End Sub 

                        ### *** :) *** ###

